# Product Extensions ## Insert Bulk Product Extensions - [POST /loaddata/PX](https://api.pricefx.com/openapi/reference/pricefx-server_openapi/product-extensions/post-loaddata-px.md): Inserts multiple product extensions to the Master Data table. The name (a name of the category) and sku must be provided for each record in the header and data object within the request body. The /loaddata operation is a very efficient and quick way to insert bulk data to the Master Data table. The main advantage is its greater speed when loading thousands of records (compared to e.g. /integrate). Use the ISO 8601 date format (YYYY-MM-DD) if a date is included in the table. >Please note: > If no joinFields are provided in the request, then this operation will insert entire records. It means that in this case (without joinFields) with /loaddata it is not possible to update just some fields (for this use the /integrate endpoint instead). The source data must always contain the entire row’s content. --- ## Upsert a Product Extension - [POST /integrate/PX](https://api.pricefx.com/openapi/reference/pricefx-server_openapi/product-extensions/post-integrate-px.md): Creates or updates a product extension. To add a new product extension that does not exist, specify the sku and name (category) parameter in the request. To update an existing product extension, specify the name and sku or typedId parameters of the existing product extension. The /integrate method performs a partial update – it does not delete values from fields that have not been specified in the update request. Use the /integrate/{TypeCode}/returnolddata endpoint to return also the data of the previous version in the response. --- Please note This method is intended to be used with one or two objects and it allows you to update particular fields. The request will overwrite the existing data of the record being updated, regardless of other changes. To work with more customers in bulk please use the /loaddata/P endpoint. --- This operation is particularly useful if the caller does not (and should not) know about typed IDs and other internal data fields, i.e. typically in an integration scenario. The only mandatory pre-requisite for this operation is that the object's defined business key fields (vary per object type) are present in every request. No typed ID or version fields are required. This also means that no version checking is performed, thus the request will overwrite existing data of that record, regardless of other changes. --- Information You can upsert multiple records using within request. To do so, add multiple data objects into your JSON. --- ## Delete a Product Extension - [POST /delete/PX](https://api.pricefx.com/openapi/reference/pricefx-server_openapi/product-extensions/post-delete-px.md): Deletes a product extension. Only one object can be deleted per request (unless batched). Some object types may be blocked from being deleted by the update command as special processing is done by a dedicated manager command. Note: Some object types are only soft-deleted, some are hard-deleted in the database. This behavior cannot be influenced by the client. ## List Product Extension Objects - [POST /productmanager.fetch/*/PX/{ProductMasterExtensionName}](https://api.pricefx.com/openapi/reference/pricefx-server_openapi/product-extensions/post-productmanager.fetch-*-typecode.md): Retrieves records from the Product Extensions table. Export the table to the Excel file (XLSX), CSV, or JSON using the output URL query parameter. When exporting to the file, specify fields (within the resultFields property) you want to include in the output table. Example request body for the export action: json { "data":{ "criteria":[ ], "operator":"and" }, "resultFields":[ "sku", "lastUpdateDate", "attribute1" ], "valueFields":[ ] } You can choose fields to be returned in the response by employing the resultFields or valueFields filter: resultFields: returns key-value pairs as objects. This is the more friendly response compared to valueFields but the server fetches all fields from the database in the backend which might result in a slower performance. See the List Products' listProductsResponseExample_resultFields response example. valueFields: returns just an array of values. Use this option if a better performance is required. See the List Products' listProductsResponseExample_valueFields response example. ## Upload a File to PX/CX/SX - [POST /importfile/{TypeCode}/{target}/{uploadSlotId}](https://api.pricefx.com/openapi/reference/pricefx-server_openapi/product-extensions/post-importfile-typecode-target-uploadslotid.md): Uploads CSV, or XLSX file to Product Extensions, Customer Extensions, or Seller Extensions table. ## Get Product Attribute Meta - [POST /productmanager.fetchpxam](https://api.pricefx.com/openapi/reference/pricefx-server_openapi/product-extensions/post-productmanager.fetchpxam.md): Extended fetch command to retrieve product attribute meta data. Unlike the general fetch/{typeCode} endpoint, this extended endpoint also handles global metadata configurations. For example, if product metadata is configured to originate from the global partition, this command will automatically retrieve it from there. In contrast, the general fetch endpoint is limited to returning data exclusively from the local partition. ## Upload a File to PX/CX/SX - [POST /importfile/{TypeCode}/{target}/{uploadSlotId}](https://api.pricefx.com/openapi/reference/pricefx-server_openapi/customer-extensions/post-importfile-typecode-target-uploadslotid.md): Uploads CSV, or XLSX file to Product Extensions, Customer Extensions, or Seller Extensions table. ## Upload a File to PX/CX/SX - [POST /importfile/{TypeCode}/{target}/{uploadSlotId}](https://api.pricefx.com/openapi/reference/pricefx-server_openapi/seller-extensions/post-importfile-typecode-target-uploadslotid.md): Uploads CSV, or XLSX file to Product Extensions, Customer Extensions, or Seller Extensions table.